unit TEST_A1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, ComCtrls, ExtCtrls, Menus, ShellAPI, FileOperator;

type
  TMainForm = class(TForm)
    Panel2: TPanel;
    PanelB: TPanel;
    DrivesA: TDriveComboBox;
    StatusB: TStatusBar;
    StatusA: TStatusBar;
    DrivesB: TDriveComboBox;
    FoldersA: TDirectoryListBox;
    FoldersB: TDirectoryListBox;
    FilesA: TFileListBox;
    FilesB: TFileListBox;
    MainMenu: TMainMenu;
    FileItem: TMenuItem;
    FileExitItem: TMenuItem;
    PopupMenu: TPopupMenu;
    OpenItem: TMenuItem;
    N1: TMenuItem;
    DeleteItem: TMenuItem;
    Operator: TFileOperator;
    N2: TMenuItem;
    SelectAllItem: TMenuItem;
    InvertSelectionItem: TMenuItem;
    CopyItem: TMenuItem;
    MoveItem: TMenuItem;
    procedure PanelBEnter(Sender: TObject);
    procedure PanelBExit(Sender: TObject);
    procedure Panel2Exit(Sender: TObject);
    procedure Panel2Enter(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure Open(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DeleteFile(Sender: TObject);
    procedure SelectAll(Sender: TObject);
    procedure InvertSelection(Sender: TObject);
    procedure CopyFiles(Sender: TObject);
    procedure MoveFiles(Sender: TObject);
  private
    FActivePanel :Integer;
    FFiles :array[ 0..1 ] of TFileListBox;
    FFolders :array[ 0..1 ] of TDirectoryListBox;
    function GetActiveDirectory :String;
    function GetActiveFolders :TDirectoryListBox;
    function GetActiveFiles :TFileListBox;
    function GetInactiveDirectory :String;
    property ActiveFiles :TFileListBox read GetActiveFiles;
    property ActiveFolders :TDirectoryListBox read GetActiveFolders;
    property ActiveDirectory :String read GetActiveDirectory;
    property InactiveDirectory :String read GetInactiveDirectory;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.PanelBEnter(Sender: TObject);
begin
  FActivePanel := 1;
end;

procedure TMainForm.PanelBExit(Sender: TObject);
begin
 FActivePanel := -1;
end;

procedure TMainForm.Panel2Exit(Sender: TObject);
begin
 FActivePanel := -1;
end;

procedure TMainForm.Panel2Enter(Sender: TObject);
begin
 FActivePanel := 0;
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
 Close;
end;

procedure TMainForm.Open(Sender: TObject);
var F :String;
begin
 with ActiveFiles do F := Items.Strings[ ItemIndex ];
 ShellExecute( Handle, 'open', PChar( F ), nil,
  PChar( ActiveDirectory ), SW_SHOWNORMAL );
end;

function TMainForm.GetActiveFolders :TDirectoryListBox;
begin
 result := FFolders[ FActivePanel ];
end;

function TMainForm.GetActiveFiles :TFileListBox;
begin
 result := FFiles[ FActivePanel ];
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FFolders[ 0 ] := FoldersA;
  FFolders[ 1 ] := FoldersB;
  FFiles[ 0 ] := FilesA;
  FFiles[ 1 ] := FilesB;
end;

function TMainForm.GetActiveDirectory :String;
begin
  result := ActiveFolders.Directory;
end;


procedure TMainForm.DeleteFile(Sender: TObject);
var F :String; I :Integer;
begin
  with ActiveFiles do
   begin
     if SelCount <= 0 then exit;
     F := '';
     for i := 0 to Items.Count - 1 do
       if Selected[ i ] then F := F + Items.Strings[ i ] + ',';
     ChDir( ActiveDirectory );
     Operator.OperandFrom := F;
     Operator.Operation := foDelete;
     Operator.Execute;
     filesa.update;
     filesb.update;
   end;
end;

procedure TMainForm.SelectAll(Sender: TObject);
var i :integer;
begin
  with ActiveFiles do
   for i := 0 to Items.Count - 1 do Selected[ i ] := true;
end;

procedure TMainForm.InvertSelection(Sender: TObject);
var i :integer;
begin
  with ActiveFiles do
   for i := 0 to Items.Count - 1 do Selected[ i ] := not Selected[ i ];
end;

procedure TMainForm.CopyFiles(Sender: TObject);
var F :String; I :Integer;
begin
  with ActiveFiles do
   begin
     if SelCount <= 0 then exit;
     F := '';
     for i := 0 to Items.Count - 1 do
       if Selected[ i ] then F := F + Items.Strings[ i ] + ',';
   end;
  ChDir( ActiveDirectory );
  with Operator do
   begin
     OperandFrom := F;
     OperandTo := InactiveDirectory;
     Operation := foCopy;
     Execute;
   end;
  filesa.update;
  filesb.update;
end;

function TMainForm.GetInactiveDirectory :String;
var i :integer;
begin
  if FActivePanel > 0 then I := 0 else I := 1;
  result := FFolders[ i ].Directory;
end;

procedure TMainForm.MoveFiles(Sender: TObject);
var F :String; I :Integer;
begin
  with ActiveFiles do
   begin
     if SelCount <= 0 then exit;
     F := '';
     for i := 0 to Items.Count - 1 do
       if Selected[ i ] then F := F + Items.Strings[ i ] + ',';
   end;
  ChDir( ActiveDirectory );
  with Operator do
   begin
     OperandFrom := F;
     OperandTo := InactiveDirectory;
     Operation := foMove;
     Execute;
   end;
  filesa.update;
  filesb.update;
end;

end.
